<template>
  <div>
    <Spin fix v-show="loading">
      <Icon type="ios-loading" size="18" class="demo-spin-icon-load"></Icon>
      <div>{{ $t('loading') }}</div>
    </Spin>
    <h1 slot="title" class="tc mb-10">
      <Icon type="md-book" />
      {{ $t('backticket.title') }}
    </h1>
    <table width="100%" class="tc" style="height:30rem">
      <thead>
        <tr>
          <th colspan="15">{{ $t('backticket.thtitle') }}</th>
        </tr>
        <tr>
          <th width="8%">{{ $t('backticket.th1') }}</th>
          <th width="15%">{{ $t('backticket.th2') }}</th>
          <th width="4%">{{ $t('backticket.th3') }}</th>
          <th width="4%">{{ $t('backticket.th4') }}</th>
          <th width="4%">{{ $t('backticket.th5') }}</th>
          <th width="4%">{{ $t('backticket.th6') }}</th>
          <th width="4%">{{ $t('backticket.th7') }}</th>
          <th width="8%">{{ $t('backticket.th8') }}</th>
          <th width="9%">{{ $t('backticket.th9') }}</th>
          <th width="12%">座位</th>
          <th width="6%">{{ $t('backticket.th10') }}</th>
          <th width="6%">{{ $t('backticket.th11') }}</th>
        </tr>
      </thead>
      <tbody>
        <tr
          v-for="(it,index) in historyData"
          :key="index+'data'"
          :class="it.backtcket=='1'? 'backticket':''"
        >
          <td>
            <font v-if="it.traintype === '10' ">
              <Icon type="md-train" />
              -{{ $t('components.trainborard.Shuttlebusfast') }}
            </font>
            <font v-if="it.traintype === '7'  ">
              <Icon type="md-train" />
              -{{ $t('components.trainborard.normalfast') }}
            </font>
            <font v-if="it.traintype === '6'  ">
              <Icon type="md-train" />
              -{{ $t('components.trainborard.Shuttlebus') }}
            </font>
            <font v-if="it.traintype === '4'  ">
              <Icon type="md-train" style="color:#0069c2" />
              -{{ $t('components.trainborard.ChuKuang') }}
            </font>
            <font v-if="it.traintype === '3'  ">
              <Icon type="md-train" style="color:orange" />
              -{{ $t('components.trainborard.TzeChiang') }}
            </font>
            <font v-if="it.traintype === '2'  ">
              <Icon type="md-train" style="color:#d00216" />
              -{{ $t('components.trainborard.Puoma') }}
            </font>
            <font v-if="it.traintype === '1'  ">
              <Icon type="md-train" style="color:#d00216" />
              -{{ $t('components.trainborard.TarokoExpress') }}
            </font>
            - ({{it.trainno}})
          </td>
          <td>{{it.startarea}} ({{it.starttime}}) - {{it.endarea}} ({{it.endtime}})</td>
          <td>{{paytime(it.date+' '+it.starttime,it.date+' '+it.endtime)}} {{ $t('components.trainborard.min') }}</td>
          <td>{{it.seatnum}} {{ $t('personticket.Bit') }}</td>
          <td>{{it.whweelseatnum}} {{ $t('personticket.Bit') }}</td>
          <td>
            <font v-if="it.tickettype == 0">{{ $t('personticket.Fullticket') }}</font>
            <font v-if="it.tickettype == 1">{{ $t('personticket.Halfticket') }}</font>
          </td>
          <td>
            <b>{{it.ticketnum}} {{ $t('personticket.Bit') }}</b>
          </td>
          <td>
            <h3>${{(it.ticketprice[0].Fares[it.tickettype].Price)*(it.whweelseatnum+it.seatnum)}} {{ $t('personticket.money') }}</h3>
          </td>
          <td>{{it.buydate}}</td>
          <td><span v-for="(it4,index) in it.seatobj" :key="index+'seat'"> <b>{{it4.seat}}</b>號 </span></td>
          <td
            v-if="!showcanticket(it.starttime,it.date)"
            style="background: #00a968;color: aliceblue;"
          >{{ $t('backticket.nopass') }}</td>
          <td
            v-if="showcanticket(it.starttime,it.date)"
            style="background: #ff4e4e;color: aliceblue;"
          >{{ $t('backticket.haspass') }}</td>
          <td>
            <Button
              type="warning"
              size="small"
              @click="sendback(it)"
              v-if="it.backtcket == '0'"
            >{{ $t('backticket.applyticket') }}</Button>
            <h4
              v-if="it.backtcket === '1'"
              style="color:#5d5d5d;"
            >{{ $t('backticket.applyticketing') }}</h4>
            <h4
              v-if="it.backtcket === '2'"
              style="color:green;"
            >{{ $t('backticket.hasapplyticket') }}</h4>
            <Button
              v-if="it.backtcket === '3'"
              type="error"
              size="small"
              @click="ticketreason(it.paybackreason,it.dealman)"
            >{{ $t('backticket.failticket') }}</Button>
          </td>
        </tr>
        <tr v-if="historyData==''">
          <td colspan="15">{{ $t('trainborard.fun_train_time_board_Message_2') }}</td>
        </tr>
      </tbody>
    </table>
    <Page ref="pages"  class="fr m-20" :total="dataCount" :page-size="pageSize" simple @on-change="changepage"></Page>
    <Divider />
    <Modal v-model="sendbackmod" :mask-closable="false" width="800">
      <h2 slot="header" style="color:#f60;text-align:center">
        <Icon type="ios-information-circle"></Icon>
        <span>{{ $t('backticket.applyticket') }}</span>
      </h2>
      <Row>
        <i-Col span="24">
          <ticketsay />
        </i-Col>
        <i-Col span="8">
          <Card class="gray m-5" dis-hover>
            <div>
              <h3 class="m-5">{{ $t('backticket.ticketmod') }}</h3>
              <CheckboxGroup
                v-for="(it,index) in sendbackmod_checkbox"
                :key="index+'ch'"
                size="large"
                v-model="selectbox"
              >
                <div class="m-10">
                  <Checkbox :label="it.value">
                    <span>{{it.label}}</span>
                  </Checkbox>
                </div>
              </CheckboxGroup>
            </div>
          </Card>
        </i-Col>
        <i-Col span="16">
          <Card class="gray m-5" dis-hover>
            <h3 class="m-5">{{ $t('backticket.ticketmod2') }}</h3>
            <Input
              type="textarea"
              :rows="6"
              :placeholder="$t('backticket.typing')"
              v-model="backreason"
            />
          </Card>
        </i-Col>
      </Row>
      <div slot="footer">
        <Button
          type="error"
          :loading="loading"
          @click="sendpayback(sendbackmoddata)"
        >{{$t('backticket.semdout')}}</Button>
        <Button type="warning" @click="sendbackmod=false,selectbox=[],backreason=''">{{$t('components.goticket.cancel')}}</Button>
      </div>
    </Modal>
  </div>
</template>

<script>
import ticketsay from "~/components/ticketpage/ticketsay.vue";
import moment from "moment";
import firebase from "firebase/app";;
import { log } from "util";
export default {
  middleware: "routerAuth",
  components: {
    ticketsay
  },
  data() {
    return {
      tabledata: [],
      loading: false,
      acount: [],
      ajaxHistoryData: [],
      // 初始化信息总条数
      dataCount: 0,
      // 每页显示多少条
      pageSize: 10,
      historyData: [],
      sendbackmod: false,
      sendbackmoddata: [],
      sendbackmod_checkbox: [
        {
          label: this.$t("backticket.checkbox1"),
          value: this.$t("backticket.checkbox1")
        },
        {
          label: this.$t("backticket.checkbox2"),
          value: this.$t("backticket.checkbox2")
        },
        {
          label: this.$t("backticket.checkbox3"),
          value: this.$t("backticket.checkbox3")
        },
        {
          label: this.$t("backticket.checkbox4"),
          value: this.$t("backticket.checkbox4")
        }
      ],
      selectbox: [],
      backreason: ""
    };
  },
  mounted() {
    this.acount = JSON.parse(localStorage.getItem("logindata"));
    this.getperosnticket();
  },
  watch: {
    tabledata(val) {
      this.handleListApproveHistory();
    }
  },
  methods: {
    // 获取历史记录信息
    handleListApproveHistory() {
      // 保存取到的所有数据
      this.ajaxHistoryData = this.tabledata;
      this.dataCount = this.tabledata.length;
      // 初始化显示，小于每页显示条数，全显，大于每页显示条数，取前每页条数显示
      if (this.tabledata.length < this.pageSize) {
        this.historyData = this.ajaxHistoryData;
      } else {
        this.historyData = this.ajaxHistoryData.slice(0, this.pageSize);
      }
      this.$nextTick(()=>{
          this.$refs['pages'].currentPage = 1;
      })
    },
    changepage(index) {
      var _start = (index - 1) * this.pageSize;
      var _end = index * this.pageSize;
      this.historyData = this.ajaxHistoryData.slice(_start, _end);
    },
    async getperosnticket() {
      const db = firebase.firestore();
      const ref = db
        .collection("ticket")
        .where("uid", "==", this.acount.user.uid);
      ref.onSnapshot(
        querySnapshot => {
          if (querySnapshot.empty) {
            console.log("資料是空的!?怎麼會是空的!!");
            return;
          }
          var result = [];
          querySnapshot.forEach(doc2 => {
            const resultdata = doc2.data();
            resultdata.keyticket = doc2.id;
            result.push(resultdata);
          });
          this.tabledata = result;
        },
        err => {
          console.log(`發生錯誤啦: ${err}`);
        }
      );
    },
    paytime(start, end) {
      if (start > end) {
        const fixend = moment(end).add(1, "days");
        const wecosttime = moment(fixend).diff(moment(start), "minutes");
        return wecosttime;
      } else {
        const wecosttime = moment(end).diff(moment(start), "minutes");
        return wecosttime;
      }
    },
    showcanticket(checktime, date) {
      const nowtime = Date.now();
      const gettime = moment(date + " " + checktime + ":" + "00").format("x");
      return nowtime > gettime;
    },
    sendback(it) {
      this.sendbackmoddata = it;
      this.sendbackmod = true;
    },
    //新增資料至管理申請退票表
    sendpayback(key) {
      this.loading = !this.loading;
      const setdata = {
        keydata: key,
        selectbox: this.selectbox,
        backreason: this.backreason,
        time: moment(Date.now()).format("LLLL")
      };
      const checkbox = this.selectbox;
      const checkreason = this.backreason;
      if (checkbox.length != 0 || checkreason != "") {
        const db = firebase.firestore();
        const ref = db.collection("paybackapply");
        ref
          .add(setdata)
          .then(data => {
            this.fixticket(key);
          })
          .catch(error => {
            this.$Message.error(this.$t("personticket.happenerror"));
          });
      } else {
        this.$Message.error(this.$t("personticket.modreason"));
        this.loading = !this.loading;
      }
    },
    //先更動車票狀態
    async fixticket(getkey) {
      const setdata = { backtcket: "1" };
      // backtcket 預設0 退票請1 退票成功2 退票駁回3
      const keyval = getkey.keyticket;
      await firebase;
      const db = firebase.firestore();
      const ref = db.collection("ticket").doc(keyval);
      ref
        .update(setdata)
        .then(data => {
          this.$Message.success(this.$t("backticket.modsend"));
          this.sendbackmod = false;
          this.loading = !this.loading;
        })
        .catch(error => {
          this.$Message.error(this.$t("personticket.happenerror"));
          this.loading = !this.loading;
        });
    },
    ticketreason(data, man) {
      this.$Message.warning({
        content:
          `
        <b>`+this.$t("backticket.dealman")+`：` + man +`</b>
        <div width="100%" class="m-5">
          <b>`+this.$t("backticket.backreason")+`:</b><br/>
          <p class="p-5 gray">` + data +`</p>
        </div>
        <div>`+this.$t("backticket.modnote")+`</div>`,
        duration: 10,
        closable: true
      });
    }
  }
};
</script>
